import numpy as np
import itertools
import os
import seaborn as sns
from matplotlib import pyplot as plt

def parse_file(filename):
    # Initialize lists to store the float values and strings
    float_values = []
    string_values = []

    # Open and read the file
    with open(filename, 'r') as file:
        for line in file:
            # Split each line into parts
            parts = line.split()

            # Separate the float values and the string
            floats = float(parts[-1])  # All but last element are floats
            string = parts[0].split('/')
            string = string[-1]  # Last element is a string

            # Append to the respective lists
            float_values.append(floats)
            string_values.append(string[:-4])

    # Convert the list of float values to a 2D numpy array
    float_array = np.array(float_values)

    return float_array, string_values

# Example usage
# Replace 'data.txt' with the path to your file
float_array, string_list = parse_file('log.txt')

idx = np.argsort(float_array)
float_array = float_array[idx]
new_string = []
for i in idx:
    new_string.append(string_list[i])
string_list = new_string



def draw_uniform_color_bar_chart(x_labels, values):
    # Create a bar chart using seaborn with a uniform color
    sns.set(style="whitegrid")
    plt.figure(figsize=(100, 6))
    bar_plot = sns.barplot(x=x_labels, y=values, color="skyblue")

    # Rotate the x labels to avoid overlapping
    plt.xticks(rotation=45, ha='right')
    plt.tight_layout()

    # Show the plot
    #.show()
    plt.savefig('stats.png')

# Example usage with the same data
draw_uniform_color_bar_chart(string_list, float_array)


