import numpy as np
import itertools
import os

def parse_file(filename):
    # Initialize lists to store the float values and strings
    float_values = []
    string_values = []

    # Open and read the file
    with open(filename, 'r') as file:
        for line in file:
            # Split each line into parts
            parts = line.split()

            # Separate the float values and the string
            floats = [float(val) for val in parts[:-1]]  # All but last element are floats
            string = parts[-1]  # Last element is a string

            # Append to the respective lists
            float_values.append(floats)
            string_values.append(string)

    # Convert the list of float values to a 2D numpy array
    float_array = np.array(float_values)

    return float_array, string_values

def save_to_file(array, strings, filename):
    print(array.shape)
    # Open the file for writing
    with open(filename, 'w') as file:
        for row, string in zip(array, strings):
            # Convert the float values in the row to a string and concatenate with the string value
            line = ' '.join(map(str, row)) + ' ' + string + '\n'
            # Write the line to the file
            file.write(line)

# Example usage
# Replace 'data.txt' with the path to your file
float_array, string_list = parse_file('all_features.txt')

segments = np.array([[0,1], [1,2], [2,3], [3,16], [16,17], [17,18], [18,30], [30,31]])
seg_names = ['centroid', 'flux', 'rms', 'mfcc', 'rolloff', 'zerox', 'chroma', 'kurtosis']
nums = range(8)
for comb_num in range(1,9):
    combinations = list(itertools.combinations(nums,comb_num))
    for combo in combinations:
        names = ''
        mask = np.zeros((31,))
        for comb in combo:
            names += seg_names[comb] + '_'
            mask[segments[comb][0]:segments[comb][1]] += 1
        names = names[:-1] + '.txt'
        #print(combo)
        ##print(mask)
        #print()
        #print(mask)
        save_to_file(float_array[:,mask.astype(np.bool)], string_list, os.path.join('all_data',names))
        #break
    #break




print(float_array.shape)
print(len(string_list))
print(string_list[2])

#print(len(list(itertools.combinations(nums,3))))
